package app.scanfood.tfm.scanfood

import app.scanfood.tfm.scanfood.scanner.NativeScannerViewFactory
import io.flutter.embedding.android.FlutterActivity
import io.flutter.embedding.engine.FlutterEngine
import androidx.lifecycle.LifecycleOwner

import androidx.lifecycle.Lifecycle

import app.scanfood.tfm.scanfood.helpers.LifecycleProvider




class MainActivity: FlutterActivity() {
    override fun configureFlutterEngine(flutterEngine: FlutterEngine) {
        super.configureFlutterEngine(flutterEngine)

        flutterEngine
                .platformViewsController
                .registry
                .registerViewFactory("scanfood/native-scanner/view", NativeScannerViewFactory(object : LifecycleProvider {
                    override fun getLifecycle(): Lifecycle {
                        return (activity as LifecycleOwner).lifecycle
                    }
                }, flutterEngine.dartExecutor.binaryMessenger))
    }
}
