import 'package:flutter/material.dart';
import 'package:flutter_localizations/flutter_localizations.dart';
import 'package:get_it/get_it.dart';
import 'package:scanfood/core/services/core_navigator_service.dart';
import 'package:scanfood/resources/l10n/l10n.dart';
import 'package:scanfood/routes.dart';
import 'package:scanfood/ui/splash_screen/splash_screen.dart';
import 'package:scanfood/ui/theme/app_theme.dart';

class ScanFood extends StatelessWidget {
  const ScanFood({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      initialRoute: SplashScreen.ROUTE,
      theme: AppTheme.lightTheme,
      routes: routes,
      localizationsDelegates: const [
        S.delegate,
        GlobalMaterialLocalizations.delegate,
        GlobalCupertinoLocalizations.delegate,
        GlobalWidgetsLocalizations.delegate
      ],
      supportedLocales: S.delegate.supportedLocales,
      navigatorKey: GetIt.I.get<CoreNavigatorService>().navigatorKey,
    );
  }
}
