import 'package:injectable/injectable.dart';
import 'package:scanfood/domain/model/objects/product.dart';
import 'package:scanfood/resources/l10n/l10n.dart';

@injectable
class AllergenToTranslation {
  final S translationStrings;

  AllergenToTranslation(this.translationStrings);

  String get lupin => translationStrings.lupin;
  String get celery => translationStrings.celery;
  String get peanuts => translationStrings.peanuts;
  String get crustaceans => translationStrings.crustaceans;
  String get sulphurDioxideAndSulphites => translationStrings.sulphur_dioxide_and_sulphites;
  String get nuts => translationStrings.nuts;
  String get gluten => translationStrings.gluten;
  String get sesameSeeds => translationStrings.sesame_seeds;
  String get eggs => translationStrings.eggs;
  String get milk => translationStrings.milk;
  String get molluscs => translationStrings.molluscs;
  String get fish => translationStrings.fish;
  String get soybeans => translationStrings.soybeans;

  String allergenToString(Allergens allergens) {
    switch (allergens) {
      case Allergens.lupin:
        return lupin;
      case Allergens.celery:
        return celery;
      case Allergens.peanuts:
        return peanuts;
      case Allergens.crustaceans:
        return crustaceans;
      case Allergens.sulphur_dioxide_and_sulphites:
        return sulphurDioxideAndSulphites;
      case Allergens.nuts:
        return nuts;
      case Allergens.gluten:
        return gluten;
      case Allergens.sesame_seeds:
        return sesameSeeds;
      case Allergens.eggs:
        return eggs;
      case Allergens.milk:
        return milk;
      case Allergens.molluscs:
        return molluscs;
      case Allergens.fish:
        return fish;
      case Allergens.soybeans:
        return soybeans;
    }
  }

  Map<Allergens, String> allergenMap() {
    return {
      Allergens.lupin: lupin,
      Allergens.celery: celery,
      Allergens.peanuts: peanuts,
      Allergens.crustaceans: crustaceans,
      Allergens.sulphur_dioxide_and_sulphites: sulphurDioxideAndSulphites,
      Allergens.nuts: nuts,
      Allergens.gluten: gluten,
      Allergens.sesame_seeds: sesameSeeds,
      Allergens.eggs: eggs,
      Allergens.milk: milk,
      Allergens.molluscs: molluscs,
      Allergens.fish: fish,
      Allergens.soybeans: soybeans,
    };
  }
}
