part of 'camera_bloc.dart';

abstract class CameraState extends Equatable {
  final int scannedElements;

  const CameraState(this.scannedElements);

  @override
  List<Object> get props => [scannedElements];
}

class CameraInitial extends CameraState {
  CameraInitial() : super(0);
}

class CameraReadyEvent extends CameraState {
  final String methodChannelName;
  final String eventChannelName;

  const CameraReadyEvent({
    required this.methodChannelName,
    required this.eventChannelName,
    int scannedElements = 0,
  }) : super(scannedElements);

  @override
  List<Object> get props => [...super.props, methodChannelName, eventChannelName];
}

class CameraHasNoPermissionsEvent extends CameraState {
  const CameraHasNoPermissionsEvent() : super(0);
}

class CameraScannedCode extends CameraState {
  const CameraScannedCode({
    required int scannedElements,
  }) : super(scannedElements);
}

class CameraBarcodeFound extends CameraState {
  const CameraBarcodeFound({
    required int scannedElements,
  }) : super(scannedElements);
}

class CameraScannedCodeLoading extends CameraState {
  const CameraScannedCodeLoading({
    required int scannedElements,
  }) : super(scannedElements);

  @override
  bool operator ==(Object other) => false;

  @override
  int get hashCode => super.hashCode;
}

class CameraScannedCodeError extends CameraState {
  const CameraScannedCodeError({
    required int scannedElements,
  }) : super(scannedElements);

  @override
  bool operator ==(Object other) => false;

  @override
  int get hashCode => super.hashCode;
}
