import 'package:injectable/injectable.dart';
import 'package:scanfood/application/list_cubit/list_cubit.dart';
import 'package:scanfood/domain/errors/no_product_found_error.dart';
import 'package:scanfood/domain/repository/product_repository.dart';

@injectable
class HistoryPageCubit extends ListCubit {
  final ProductRepository _productRepository;

  HistoryPageCubit(this._productRepository) : super(false, {}, true, {});

  Future<void> loadHistory() async {
    try {
      products
        ..clear()
        ..addAll(await _productRepository.getAll());

      emit(ListState(products: products, disabledAllergens: disabledAllergens, userHasSearched: true, loading: false));
    } on NoProductFoundError catch (_) {}
  }
}
