import 'package:injectable/injectable.dart';
import 'package:scanfood/application/list_cubit/list_cubit.dart';
import 'package:scanfood/domain/model/value_objects/barcode.dart';
import 'package:scanfood/domain/repository/product_repository.dart';

@lazySingleton
class ScanResultCubit extends ListCubit {
  final ProductRepository _productRepository;

  ScanResultCubit(this._productRepository) : super(false, {}, false, {});

  Future<void> addBarcode(Barcode barcode) async {
    products.add(await _productRepository.findProductByBarcode(barcode));

    emit(ListState(
      loading: false,
      userHasSearched: true,
      products: products,
      disabledAllergens: disabledAllergens,
    ));
  }

  void clearProducts() {
    products.clear();

    emit(ListState(
      loading: false,
      userHasSearched: true,
      products: products,
      disabledAllergens: disabledAllergens,
    ));
  }
}
