import 'package:injectable/injectable.dart';
import 'package:scanfood/application/list_cubit/list_cubit.dart';
import 'package:scanfood/domain/repository/product_repository.dart';

@injectable
class SearchCubit extends ListCubit {
  final ProductRepository _productRepository;

  SearchCubit(this._productRepository) : super(false, {}, false, {});

  Future<void> search(String text) async {
    products.clear();

    emit(ListState(
      loading: true,
      userHasSearched: true,
      products: products,
      disabledAllergens: disabledAllergens,
    ));

    products.addAll(await _productRepository.searchByText(text));

    emit(ListState(
      loading: false,
      userHasSearched: true,
      products: products,
      disabledAllergens: disabledAllergens,
    ));
  }
}
