import 'package:firebase_crashlytics/firebase_crashlytics.dart';
import 'package:flutter/foundation.dart';
import 'package:injectable/injectable.dart';

@lazySingleton
class CoreCrashlytics {
  void init() {
    FirebaseCrashlytics.instance.setCrashlyticsCollectionEnabled(true);
    FlutterError.onError = FirebaseCrashlytics.instance.recordFlutterError;
  }

  Future<void> logError({
    required dynamic exception,
    required StackTrace stack,
  }) async {
    FirebaseCrashlytics.instance.recordError(exception, stack);
  }
}