import 'package:firebase_analytics/firebase_analytics.dart';
import 'package:firebase_analytics/observer.dart';
import 'package:injectable/injectable.dart';

@lazySingleton
class CoreGAnalytics {
  late FirebaseAnalytics _firebaseAnalytics;
  late FirebaseAnalyticsObserver _firebaseAnalyticsObserver;

  FirebaseAnalyticsObserver get observer => _firebaseAnalyticsObserver;

  void init() async {
    _firebaseAnalytics = FirebaseAnalytics();
    _firebaseAnalyticsObserver = FirebaseAnalyticsObserver(analytics: _firebaseAnalytics);
  }

  void setUserId(String userId) {
    _firebaseAnalytics.setUserId(userId);
  }

  void logEvent({required String eventName, Map<String, Object?>? parameters}) {
    _firebaseAnalytics.logEvent(
      name: eventName,
      parameters: parameters,
    );
  }

  void setCurrentScreen({required String screenName}) {
    _firebaseAnalytics.setCurrentScreen(screenName: screenName);
  }
}