import 'dart:async';

import 'package:get_storage/get_storage.dart';
import 'package:injectable/injectable.dart';

@lazySingleton
class CoreLocalStorage {
  final GetStorage _storage = GetStorage();
  bool storageActive = false;

  Future<void> init() async {
    await GetStorage.init();
    storageActive = true;
  }

  void guardClause() {
    assert(storageActive, 'CoreLocalStorage not initialized');
  }

  T read<T>(String key) {
    guardClause();
    return _storage.read(key);
  }

  bool hasData(String key) {
    guardClause();
    return _storage.hasData(key);
  }

  Future<void> write(String key, dynamic value) async {
    guardClause();
    return _storage.write(key, value);
  }
}
