import 'package:firebase_core/firebase_core.dart';
import 'package:google_mobile_ads/google_mobile_ads.dart';
import 'package:injectable/injectable.dart';
import 'package:scanfood/core/firebase/core_crashlytics.dart';
import 'package:scanfood/core/firebase/core_g_analytics.dart';
import 'package:scanfood/core/local_storage/core_local_storage.dart';

@injectable
class CoreStartupService {
  final CoreCrashlytics _coreCrashlytics;
  final CoreGAnalytics _coreGAnalytics;
  final CoreLocalStorage _coreLocalStorage;

  CoreStartupService(this._coreCrashlytics, this._coreGAnalytics, this._coreLocalStorage);

  Future<void> execute() async {
    await Firebase.initializeApp();

    _coreCrashlytics.init();
    _coreGAnalytics.init();

    MobileAds.instance.initialize();

    await _coreLocalStorage.init();
  }
}
