import 'package:hive/hive.dart';
import 'package:scanfood/domain/model/objects/product.dart';

part 'hive_enums.g.dart';

@HiveType(typeId: 101)
enum HiveNutrientLevel {
  @HiveField(0)
  unknown,
  @HiveField(1)
  low,
  @HiveField(2)
  medium,
  @HiveField(3)
  high,
}

@HiveType(typeId: 102)
enum HiveEcoScoreLevel {
  @HiveField(0)
  unknown,
  @HiveField(1)
  A,
  @HiveField(2)
  B,
  @HiveField(3)
  C,
  @HiveField(4)
  D,
  @HiveField(5)
  E,
}

@HiveType(typeId: 103)
enum HiveNutriScoreLevel {
  @HiveField(0)
  unknown,
  @HiveField(1)
  A,
  @HiveField(2)
  B,
  @HiveField(3)
  C,
  @HiveField(4)
  D,
  @HiveField(5)
  E,
}

@HiveType(typeId: 104)
enum HiveNOVA {
  @HiveField(0)
  unknown,
  @HiveField(1)
  A,
  @HiveField(2)
  B,
  @HiveField(3)
  C,
  @HiveField(4)
  D,
}

@HiveType(typeId: 105)
enum HiveAllergens {
  @HiveField(0)
  lupin,
  @HiveField(1)
  celery,
  @HiveField(2)
  peanuts,
  @HiveField(3)
  crustaceans,
  @HiveField(4)
  sulphur_dioxide_and_sulphites,
  @HiveField(5)
  nuts,
  @HiveField(6)
  gluten,
  @HiveField(7)
  sesame_seeds,
  @HiveField(8)
  eggs,
  @HiveField(9)
  milk,
  @HiveField(10)
  molluscs,
  @HiveField(11)
  fish,
  @HiveField(12)
  soybeans,
}

class EnumFactory {
  static NutrientLevel hiveNutrientLevelToNutrientLevel(HiveNutrientLevel hiveNutrientLevel) {
    switch (hiveNutrientLevel) {
      case HiveNutrientLevel.unknown:
        return NutrientLevel.unknown;
      case HiveNutrientLevel.low:
        return NutrientLevel.low;
      case HiveNutrientLevel.medium:
        return NutrientLevel.medium;
      case HiveNutrientLevel.high:
        return NutrientLevel.high;
    }
  }

  static HiveNutrientLevel nutrientLevelToHiveNutrientLevel(NutrientLevel nutrientLevel) {
    switch (nutrientLevel) {
      case NutrientLevel.unknown:
        return HiveNutrientLevel.unknown;
      case NutrientLevel.low:
        return HiveNutrientLevel.low;
      case NutrientLevel.medium:
        return HiveNutrientLevel.medium;
      case NutrientLevel.high:
        return HiveNutrientLevel.high;
    }
  }

  static EcoScoreLevel hiveEcoScoreLevelToEcoScoreLevel(HiveEcoScoreLevel hiveEcoScoreLevel) {
    switch (hiveEcoScoreLevel) {
      case HiveEcoScoreLevel.unknown:
        return EcoScoreLevel.unknown;
      case HiveEcoScoreLevel.A:
        return EcoScoreLevel.A;
      case HiveEcoScoreLevel.B:
        return EcoScoreLevel.B;
      case HiveEcoScoreLevel.C:
        return EcoScoreLevel.C;
      case HiveEcoScoreLevel.D:
        return EcoScoreLevel.D;
      case HiveEcoScoreLevel.E:
        return EcoScoreLevel.E;
    }
  }

  static HiveEcoScoreLevel ecoScoreLevelToHiveScoreLevel(EcoScoreLevel ecoScoreLevel) {
    switch (ecoScoreLevel) {
      case EcoScoreLevel.unknown:
        return HiveEcoScoreLevel.unknown;
      case EcoScoreLevel.A:
        return HiveEcoScoreLevel.A;
      case EcoScoreLevel.B:
        return HiveEcoScoreLevel.B;
      case EcoScoreLevel.C:
        return HiveEcoScoreLevel.C;
      case EcoScoreLevel.D:
        return HiveEcoScoreLevel.D;
      case EcoScoreLevel.E:
        return HiveEcoScoreLevel.E;
    }
  }

  static NutriScoreLevel hiveNutriScoreLevelToNutriScoreLevel(HiveNutriScoreLevel hiveNutriScoreLevel) {
    switch (hiveNutriScoreLevel) {
      case HiveNutriScoreLevel.unknown:
        return NutriScoreLevel.unknown;
      case HiveNutriScoreLevel.A:
        return NutriScoreLevel.A;
      case HiveNutriScoreLevel.B:
        return NutriScoreLevel.B;
      case HiveNutriScoreLevel.C:
        return NutriScoreLevel.C;
      case HiveNutriScoreLevel.D:
        return NutriScoreLevel.D;
      case HiveNutriScoreLevel.E:
        return NutriScoreLevel.E;
    }
  }

  static HiveNutriScoreLevel nutriScoreLevelToHiveNutriScoreLevel(NutriScoreLevel nutriScoreLevel) {
    switch (nutriScoreLevel) {
      case NutriScoreLevel.unknown:
        return HiveNutriScoreLevel.unknown;
      case NutriScoreLevel.A:
        return HiveNutriScoreLevel.A;
      case NutriScoreLevel.B:
        return HiveNutriScoreLevel.B;
      case NutriScoreLevel.C:
        return HiveNutriScoreLevel.C;
      case NutriScoreLevel.D:
        return HiveNutriScoreLevel.D;
      case NutriScoreLevel.E:
        return HiveNutriScoreLevel.E;
    }
  }

  static NOVALevel hiveNOVAToNOVA(HiveNOVA hiveNOVA) {
    switch (hiveNOVA) {
      case HiveNOVA.unknown:
        return NOVALevel.unknown;
      case HiveNOVA.A:
        return NOVALevel.A;
      case HiveNOVA.B:
        return NOVALevel.B;
      case HiveNOVA.C:
        return NOVALevel.C;
      case HiveNOVA.D:
        return NOVALevel.D;
    }
  }

  static HiveNOVA novaToHiveNOVA(NOVALevel nova) {
    switch (nova) {
      case NOVALevel.unknown:
        return HiveNOVA.unknown;
      case NOVALevel.A:
        return HiveNOVA.A;
      case NOVALevel.B:
        return HiveNOVA.B;
      case NOVALevel.C:
        return HiveNOVA.C;
      case NOVALevel.D:
        return HiveNOVA.D;
    }
  }

  static Allergens hiveAllergensToAllergens(HiveAllergens hiveAllergens) {
    switch (hiveAllergens) {
      case HiveAllergens.lupin:
        return Allergens.lupin;
      case HiveAllergens.celery:
        return Allergens.celery;
      case HiveAllergens.peanuts:
        return Allergens.peanuts;
      case HiveAllergens.crustaceans:
        return Allergens.crustaceans;
      case HiveAllergens.sulphur_dioxide_and_sulphites:
        return Allergens.sulphur_dioxide_and_sulphites;
      case HiveAllergens.nuts:
        return Allergens.nuts;
      case HiveAllergens.gluten:
        return Allergens.gluten;
      case HiveAllergens.sesame_seeds:
        return Allergens.sesame_seeds;
      case HiveAllergens.eggs:
        return Allergens.eggs;
      case HiveAllergens.milk:
        return Allergens.milk;
      case HiveAllergens.molluscs:
        return Allergens.molluscs;
      case HiveAllergens.fish:
        return Allergens.fish;
      case HiveAllergens.soybeans:
        return Allergens.soybeans;
    }
  }

  static HiveAllergens allergensToHiveAllergens(Allergens allergens) {
    switch (allergens) {
      case Allergens.lupin:
        return HiveAllergens.lupin;
      case Allergens.celery:
        return HiveAllergens.celery;
      case Allergens.peanuts:
        return HiveAllergens.peanuts;
      case Allergens.crustaceans:
        return HiveAllergens.crustaceans;
      case Allergens.sulphur_dioxide_and_sulphites:
        return HiveAllergens.sulphur_dioxide_and_sulphites;
      case Allergens.nuts:
        return HiveAllergens.nuts;
      case Allergens.gluten:
        return HiveAllergens.gluten;
      case Allergens.sesame_seeds:
        return HiveAllergens.sesame_seeds;
      case Allergens.eggs:
        return HiveAllergens.eggs;
      case Allergens.milk:
        return HiveAllergens.milk;
      case Allergens.molluscs:
        return HiveAllergens.molluscs;
      case Allergens.fish:
        return HiveAllergens.fish;
      case Allergens.soybeans:
        return HiveAllergens.soybeans;
    }
  }
}
