import 'package:get_it/get_it.dart';
import 'package:injectable/injectable.dart';
import 'package:permission_handler/permission_handler.dart';
import 'package:scanfood/resources/l10n/l10n.dart';

import 'injection.config.dart';

@InjectableInit(
  initializerName: r'$initGetIt', // default
  preferRelativeImports: true, // default
  asExtension: false, // default
)
GetIt configureDependencies() => $initGetIt(GetIt.instance);

@module
abstract class RegisterModule {
  // Translations
  S get translation => S.current;

  @Named('appTrackingTransparency')
  Permission get appTrackingTransparency => Permission.appTrackingTransparency;
}
