import 'package:flutter/cupertino.dart';
import 'package:get_it/get_it.dart';
import 'package:scanfood/ui/item_screen/item_page.dart';
import 'package:scanfood/ui/main_screen/main_screen.dart';
import 'package:scanfood/ui/onboarding_screen/onboarding_screen.dart';
import 'package:scanfood/ui/results_page/results_page.dart';
import 'package:scanfood/ui/splash_screen/splash_screen.dart';

import 'application/service/application_startup_service.dart';
import 'core/widgets/splash_holder.dart';

final Map<String, WidgetBuilder> routes = {
  SplashScreen.ROUTE: (_) => SplashHolder(
        failedRoute: SplashScreen.ROUTE,
        splashWidget: const SplashScreen(),
        postInitDecisionFunction: GetIt.I.get<ApplicationStartupService>().execute,
      ),
  OnboardingScreen.ROUTE: (_) => const OnboardingScreen(),
  MainScreen.ROUTE: (_) => const MainScreen(),
  ResultPage.ROUTE: (_) => const ResultPage(),
  ItemPage.ROUTE: (_) => const ItemPage(),
};
