part of '../camera_page.dart';

class _CameraCounter extends StatelessWidget {
  static const double BOX_SIZE = 75;
  final int itemsScanned;
  final bool loading;

  const _CameraCounter({
    Key? key,
    required this.itemsScanned,
    required this.loading,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Container(
      width: BOX_SIZE,
      height: BOX_SIZE,
      decoration: const BoxDecoration(
        borderRadius: BorderRadius.only(topLeft: Radius.circular(8), bottomLeft: Radius.circular(8)),
        color: AppTheme.primary800,
      ),
      child: Align(
        alignment: Alignment.center,
        child: Container(
          width: 30,
          height: 30,
          decoration: BoxDecoration(
            borderRadius: BorderRadius.circular(80),
            color: AppTheme.complementary800,
          ),
          child: Align(
            alignment: Alignment.center,
            child: loading
                ? const CircularProgressIndicator()
                : Text(
                    itemsScanned.toString(),
                    style: Theme.of(context).textTheme.headline4!.copyWith(color: Colors.white),
                  ),
          ),
        ),
      ),
    );
  }
}
