part of '../camera_page.dart';

class _CameraRectanglePainter extends CustomPainter {
  static const double markerSize = 34;
  static const double paddingLateral = 32;

  final double topMargin;
  final Color colorLine;

  const _CameraRectanglePainter({
    required this.topMargin,
    required this.colorLine,
  });

  @override
  void paint(Canvas canvas, Size size) {
    final double rectangleHeight = size.width - paddingLateral * 2;

    final Paint strokeLines = Paint()
      ..strokeCap = StrokeCap.round
      ..strokeWidth = 6
      ..color = colorLine;

    final double startPoint = size.height / 2 - rectangleHeight / 2 + topMargin / 2;

    canvas
      // Top Left Lines
      ..drawLine(
        Offset(paddingLateral + markerSize, startPoint),
        Offset(paddingLateral, startPoint),
        strokeLines,
      )
      ..drawLine(
        Offset(paddingLateral, startPoint),
        Offset(paddingLateral, startPoint + markerSize),
        strokeLines,
      )
      // Top Right Lines
      ..drawLine(
        Offset(size.width - paddingLateral, startPoint),
        Offset(size.width - paddingLateral - markerSize, startPoint),
        strokeLines,
      )
      ..drawLine(
        Offset(size.width - paddingLateral, startPoint),
        Offset(size.width - paddingLateral, startPoint + markerSize),
        strokeLines,
      )
      // Bottom Left Lines
      ..drawLine(
        Offset(paddingLateral + markerSize, startPoint + rectangleHeight),
        Offset(paddingLateral, startPoint + rectangleHeight),
        strokeLines,
      )
      ..drawLine(
        Offset(paddingLateral, startPoint + rectangleHeight),
        Offset(paddingLateral, startPoint + rectangleHeight - markerSize),
        strokeLines,
      )
      // Bottom Right Lines
      ..drawLine(
        Offset(size.width - paddingLateral, startPoint + rectangleHeight),
        Offset(size.width - paddingLateral - markerSize, startPoint + rectangleHeight),
        strokeLines,
      )
      ..drawLine(
        Offset(size.width - paddingLateral, startPoint + rectangleHeight),
        Offset(size.width - paddingLateral, startPoint + rectangleHeight - markerSize),
        strokeLines,
      );
  }

  @override
  bool shouldRepaint(CustomPainter oldDelegate) => true;
}
