import 'dart:io';

import 'package:flutter/material.dart';
import 'package:google_mobile_ads/google_mobile_ads.dart';

class CommonAdmobBannerAd extends StatefulWidget {
  const CommonAdmobBannerAd({Key? key}) : super(key: key);

  @override
  _CommonAdmobBannerAdState createState() => _CommonAdmobBannerAdState();
}

class _CommonAdmobBannerAdState extends State<CommonAdmobBannerAd> {
  final BannerAd _bannerAd = BannerAd(
    adUnitId: Platform.isAndroid ? 'ca-app-pub-6220172595868302/2992806958' : 'ca-app-pub-6220172595868302/3845711869',
    size: AdSize.banner,
    request: const AdRequest(),
    listener: const BannerAdListener(),
  );

  @override
  void initState() {
    _bannerAd.load();
    super.initState();
  }

  @override
  void dispose() {
    _bannerAd.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      alignment: Alignment.center,
      child: AdWidget(ad: _bannerAd),
      width: _bannerAd.size.width.toDouble(),
      height: _bannerAd.size.height.toDouble(),
    );
  }
}
