import 'package:flutter/material.dart';
import 'package:scanfood/ui/theme/app_theme.dart';

class CommonButton extends StatelessWidget {
  final String title;
  final Color color;
  final Color? textColor;
  final void Function() onPressed;

  const CommonButton({
    required this.title,
    required this.color,
    this.textColor,
    required this.onPressed,
  });

  const CommonButton.settingsButton({required this.title, required this.onPressed})
      : color = AppTheme.neutral700,
        textColor = AppTheme.neutral200;

  @override
  Widget build(BuildContext context) {
    return OutlinedButton(
      style: OutlinedButton.styleFrom(
        primary: textColor,
        side: BorderSide(
          color: color,
        ),
      ),
      onPressed: onPressed,
      child: Text(
        title,
        style: Theme.of(context).textTheme.button?.copyWith(color: textColor),
      ),
    );
  }
}
