import 'package:scanfood/domain/model/objects/product.dart';

mixin ProductQualifiersToSvg {
  String ecoScoreToSvg(EcoScoreLevel ecoScoreLevel) {
    switch (ecoScoreLevel) {
      case EcoScoreLevel.unknown:
        return 'assets/qualifiers/ecoscore-unknown.svg';
      case EcoScoreLevel.A:
        return 'assets/qualifiers/ecoscore-a.svg';
      case EcoScoreLevel.B:
        return 'assets/qualifiers/ecoscore-b.svg';
      case EcoScoreLevel.C:
        return 'assets/qualifiers/ecoscore-c.svg';
      case EcoScoreLevel.D:
        return 'assets/qualifiers/ecoscore-d.svg';
      case EcoScoreLevel.E:
        return 'assets/qualifiers/ecoscore-e.svg';
    }
  }

  String nutriscoreToSvg(NutriScoreLevel nutriScoreLevel) {
    switch (nutriScoreLevel) {
      case NutriScoreLevel.unknown:
        return 'assets/qualifiers/nutriscore-unknown.svg';
      case NutriScoreLevel.A:
        return 'assets/qualifiers/nutriscore-a.svg';
      case NutriScoreLevel.B:
        return 'assets/qualifiers/nutriscore-b.svg';
      case NutriScoreLevel.C:
        return 'assets/qualifiers/nutriscore-c.svg';
      case NutriScoreLevel.D:
        return 'assets/qualifiers/nutriscore-d.svg';
      case NutriScoreLevel.E:
        return 'assets/qualifiers/nutriscore-e.svg';
    }
  }

  String novaToSvg(NOVALevel novaLevel) {
    switch (novaLevel) {
      case NOVALevel.unknown:
        return 'assets/qualifiers/nova-group-unknown.svg';
      case NOVALevel.A:
        return 'assets/qualifiers/nova-group-1.svg';
      case NOVALevel.B:
        return 'assets/qualifiers/nova-group-2.svg';
      case NOVALevel.C:
        return 'assets/qualifiers/nova-group-3.svg';
      case NOVALevel.D:
        return 'assets/qualifiers/nova-group-4.svg';
    }
  }
}
