import 'package:cached_network_image/cached_network_image.dart';
import 'package:flutter/material.dart';
import 'package:flutter_svg/flutter_svg.dart';
import 'package:scanfood/domain/model/objects/product.dart';
import 'package:scanfood/resources/l10n/l10n.dart';
import 'package:scanfood/ui/common/common_admob_banner_ad.dart';
import 'package:scanfood/ui/common/common_app_bar.dart';
import 'package:scanfood/ui/helpers/allergens_to_string.dart';
import 'package:scanfood/ui/helpers/nutrition_level_to_color.dart';
import 'package:scanfood/ui/helpers/product_qualifiers_to_svg.dart';
import 'package:scanfood/ui/theme/app_theme.dart';

part 'item_page_contents.dart';

class ItemPageParams {
  final Product product;

  ItemPageParams({
    required this.product,
  });
}

class ItemPage extends StatelessWidget {
  static const ROUTE = '/item';

  const ItemPage({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    final args = ModalRoute.of(context)!.settings.arguments as ItemPageParams;

    return _ItemPageContents(product: args.product);
  }
}
