import 'package:flutter_test/flutter_test.dart';
import 'package:mockito/annotations.dart';
import 'package:mockito/mockito.dart';
import 'package:scanfood/application/service/onboarding_notifier_service.dart';
import 'package:scanfood/domain/repository/onboarding_status_repository.dart';

import 'onboarding_notifier_service_test.mocks.dart';

@GenerateMocks([
  OnboardingStatusRepository,
])
void main() {
  group('Onboarding notifier service', () {
    test('-> execute', () async {
      final MockOnboardingStatusRepository mockOnboardingStatusRepository = MockOnboardingStatusRepository();

      when(mockOnboardingStatusRepository.onboardShowed()).thenAnswer((realInvocation) => Future.value());

      final OnboardingNotifierService onboardingNotifierService =
          OnboardingNotifierService(mockOnboardingStatusRepository);

      await onboardingNotifierService.execute();

      verify(mockOnboardingStatusRepository.onboardShowed()).called(1);
    });
  });
}
