import 'package:faker/faker.dart';
import 'package:scanfood/domain/model/objects/product.dart';
import 'package:scanfood/domain/model/value_objects/barcode.dart';

import '../value_objects/barcode_mock.dart';

Product generateMockProduct({
  Barcode? barcode,
  List<Allergens>? allergens,
}) {
  final Faker faker = Faker();

  return Product(
    productName: faker.vehicle.model(),
    brand: faker.vehicle.make(),
    quantity: faker.randomGenerator.numberOfLength(5),
    barcode: barcode ?? generateBarcodeMock(),
    sugarsLevel: faker.randomGenerator.element(NutrientLevel.values),
    fatLevel: faker.randomGenerator.element(NutrientLevel.values),
    saturatedFatLevel: faker.randomGenerator.element(NutrientLevel.values),
    saltLevel: faker.randomGenerator.element(NutrientLevel.values),
    ecoScoreLevel: faker.randomGenerator.element(EcoScoreLevel.values),
    nutriScoreLevel: faker.randomGenerator.element(NutriScoreLevel.values),
    nova: faker.randomGenerator.element(NOVALevel.values),
    allergens: allergens ?? [],
    imageUrl: faker.internet.httpsUrl(),
    salt: faker.randomGenerator.decimal(),
    fat: faker.randomGenerator.decimal(),
    saturatedFat: faker.randomGenerator.decimal(),
    sugars: faker.randomGenerator.decimal(),
  );
}
